# twins
[![CI status](https://gitlab.com/tslocum/twins/badges/master/pipeline.svg)](https://gitlab.com/tslocum/twins/commits/master)
[![Donate](https://img.shields.io/liberapay/receives/rocketnine.space.svg?logo=liberapay)](https://liberapay.com/rocketnine.space)

[Gemini](https://gemini.circumlunar.space) server

**Warning:** The twins configuration format is still under development.
Breaking changes may be made.

This page is also available at [gemini://twins.rocketnine.space](gemini://twins.rocketnine.space)

## Features

- Serve static files
  - List files and directories (when enabled)
- Reverse proxy requests
  - TCP
  - [FastCGI](https://en.wikipedia.org/wiki/FastCGI)
- Serve system command output
- Reload configuration on `SIGHUP`

## Download

```bash
go get gitlab.com/tslocum/twins
```

## Configure

See [CONFIGURATION.md](https://gitlab.com/tslocum/twins/blob/master/CONFIGURATION.md)

## Run

```bash
twins
```

## Support

Please share issues and suggestions [here](https://gitlab.com/tslocum/twins/issues).

## Dependencies

- [filetype](https://github.com/h2non/filetype) - MIME type detection
- [gofast](https://github.com/yookoala/gofast) - FastCGI client
- [go-shellquote](https://github.com/kballard/go-shellquote) - Shell string quoting
- [yaml](https://github.com/go-yaml/yaml/tree/v3) - Configuration parsing
